-- Tests: account_party_link.validity_start_time
-- Severity: ERROR
-- Description: All values are before the interval end date (if provided) and before today's date
-- Interpretation: If matching_rows > 0, fix validity_start_time after today
SELECT
  "t4"."total_rows",
  "t4"."matching_rows",
  "t4"."matching_rows" / "t4"."total_rows" AS "proportion"
FROM (
  SELECT
    COUNT(*) AS "total_rows",
    COUNT_IF("t3"."validity_start_time" > CURRENT_TIMESTAMP()) AS "matching_rows"
  FROM (
    SELECT
      *
    FROM (
      SELECT
        "t1"."account_id",
        "t1"."party_id",
        "t1"."validity_start_time",
        "t1"."is_entity_deleted",
        "t1"."role",
        "t1"."source_system",
        ROW_NUMBER() OVER (PARTITION BY "t1"."account_id", "t1"."party_id" ORDER BY "t1"."validity_start_time" DESC NULLS LAST) - 1 AS "row_num"
      FROM (
        SELECT
          *
        FROM "PLACEHOLDER"."account_party_link" AS "t0"
        WHERE
          NOT (
            "t0"."is_entity_deleted"
          ) OR (
            "t0"."is_entity_deleted" IS NULL
          )
      ) AS "t1"
    ) AS "t2"
    WHERE
      "t2"."row_num" = 0
  ) AS "t3"
) AS "t4"
